ps = {} -- particles

function particles_update(dt)
	for i,v in ipairs(ps) do
		local dx = math.cos(v.a) * v.s
		local dy = math.sin(v.a) * v.s
		
		v.x = v.x + dx * dt
		v.y = v.y + dy * dt
		
		v.s = v.s - 100 * dt
		v.w = (v.s/100)*5
		
		if(v.s <= 0) then
			table.remove(ps,i)
		end
	end
end

function particles_draw()
	for i,v in ipairs(ps) do
		love.graphics.rectangle("fill",v.x,v.y,v.w,v.w)
	end
end

function particle_spawn(x,y,amount,speed,width)
	for i=1,amount do
		p = {}
		p.x = x
		p.y = y
		p.a = math.random(0,62)/10
		p.s = speed
		p.w = width
		
		table.insert(ps,p)
	end
end