player = {}
player.y = 1
player.c = 3 -- player's colour
player.life = 3

player.ty = 1 -- player's y tile

fallSpeed = 1
fallAc = 0.1 -- fall speed acceleration

player.r = 0 -- to tween colours
player.g = 0
player.b = 0

player.tr = 0 -- to tween colours, targets
player.tg = 0
player.tb = 255

cTweenSpeed = 4 -- colour tween speed
checkpoint = 1

lastc = 0
function player_update(dt)
	if(player.life >= 0) then
		player.y = player.y + fallSpeed * dt
		fallSpeed = fallSpeed + fallAc * dt
	end
	
	-- Change colour
	if(love.keyboard.isDown("q")) then -- red
		player.c = 1
		player.tr = 255
		player.tg = 0
		player.tb = 0
	elseif(love.keyboard.isDown("w")) then -- green
		player.c = 2
		player.tr = 0
		player.tg = 255
		player.tb = 0
	elseif(love.keyboard.isDown("e")) then -- blue
		player.c = 3
		player.tr = 0
		player.tg = 0
		player.tb = 255
	end
	
	-- tween colours
	player.r = player.r + (player.tr - player.r) * cTweenSpeed * dt
	player.g = player.g + (player.tg - player.g) * cTweenSpeed * dt
	player.b = player.b + (player.tb - player.b) * cTweenSpeed * dt
	
	-- collision
	if(math.floor(player.y + 1) ~= player.ty) then -- tile y has changed
		player.ty = math.floor(player.y + 1)
		if(player.ty < #map) then
			if(map[player.ty] ~= lastc) then
				lastc = 0
			end
			if(player.c == 1 and lastc ~= 1) then
				if(map[player.ty] == 1) then
					hit()
				end
			elseif(player.c == 2 and lastc ~= 2) then
				if(map[player.ty] == 2) then
					hit()
				end			
			elseif(player.c == 3 and lastc ~= 3) then
				if(map[player.ty] == 3) then
					hit()
				end			
			end
			if(map[player.ty] == 4) then
				checkpoint = player.ty
				fallSpeed = 1
				player.life = 3
			end
		else
			player.y = 1
			fallSpeed = 1
			player.life = 3
		end
	end
	
	if(player.life < 0 and love.keyboard.isDown("q") and love.keyboard.isDown("w") and love.keyboard.isDown("e")) then
		player.y = checkpoint
		fallSpeed = 1
		player.life = 3
	end
	
	if(love.keyboard.isDown("escape")) then
		state = "menu"
	end
end

function hit()
	player.life = player.life - 1
	cam.x = cam.x + math.random(-10,10)
	particle_spawn(tileSize/2,player.y*tileSize,10,100,5)
	lastc = map[player.ty]
	
	if(player.life < 0) then
		particle_spawn(tileSize/2,player.y*tileSize,30,100,10)	
	end
end

function player_draw()

	
	love.graphics.setColor(player.r,player.g,player.b)
	love.graphics.rectangle("fill",0,player.y*tileSize,tileSize,tileSize)
	love.graphics.setColor(255,255,255)
	
	love.graphics.rectangle("line",0,player.y*tileSize,tileSize,tileSize)
	
	--love.graphics.line(0,0,0,screen.h)
	--love.graphics.line(tileSize,0,tileSize,screen.h)
end

function hud_draw()
	--love.graphics.line(screen.w/2 - tileSize/2,0,screen.w/2 - tileSize/2,screen.h)

	love.graphics.setColor(0,0,255)
	love.graphics.rectangle("fill",screen.w/2-15 + 40,32,30,30)
	
	love.graphics.setColor(0,255,0)
	love.graphics.rectangle("fill",screen.w/2 - 15,32,30,30)
	
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("fill",screen.w/2 - 55,32,30,30)
	
	love.graphics.setColor(255,255,255)
	
	love.graphics.setColor(player.r,player.g,player.b)
	if(player.life >=3) then
		love.graphics.rectangle("fill",screen.w/2 - 15 + 40,screen.h - 40,30,30)
	end
	if(player.life >=2) then
		love.graphics.rectangle("fill",screen.w/2 - 15,screen.h - 40,30,30)
	end
	if(player.life >=1) then
		love.graphics.rectangle("fill",screen.w/2 - 55,screen.h - 40,30,30)
	end
	
	love.graphics.setColor(255,255,255)
	
	if(player.life < 0) then
		love.graphics.print("Press Q + W + E to retry", screen.w/2 - 75, 300)
	end
	love.graphics.setColor(255,255,255)
end