state = "menu"

title = love.graphics.newImage("title.png")

function state_update(dt)
	if(state == "menu") then
		menu_update()
	elseif(state == "game") then
		game_update(dt)
	end
end

function state_draw()
	if(state == "menu") then
		menu_draw()
	elseif(state == "game") then
		game_draw()
	end
end

function menu_update()
	if(love.keyboard.isDown("q") and love.keyboard.isDown("w") and love.keyboard.isDown("e")) then
		state = "game"
	end
end

function menu_draw()
	love.graphics.setBackgroundColor(0,0,0)
	
	love.graphics.setColor(255,0,0,back)
	love.graphics.rectangle("fill",0,0,screen.w/3,screen.h)

	love.graphics.setColor(0,255,0,back)
	love.graphics.rectangle("fill",screen.w/3,0,screen.w/3,screen.h)
	
	love.graphics.setColor(0,0,255,back)
	love.graphics.rectangle("fill",(screen.w/3)*2,0,screen.w/3,screen.h)
	
	love.graphics.setColor(255,255,255)
	
	love.graphics.draw(title,screen.w/2 - 100,100)
	
	--love.graphics.setColor(255,0,0)
	--love.graphics.rectangle("fill",screen.w/2 - 50,250,100,50) -- play button
	
	love.graphics.setColor(0,0,0)
	love.graphics.print("Press Q + W + E to play",screen.w/2 - 75,250)
	
	love.graphics.setColor(255,255,255)
end

function game_update(dt)
	level_update(dt)
	player_update(dt)
	particles_update(dt)
	
	cam.ty = -player.y * tileSize + 100
	cam.tx = screen.w/2 - tileSize/2
	
	cam.x = cam.x + (cam.tx - cam.x) * cam.s * dt
	cam.y = cam.y + (cam.ty - cam.y) * cam.s * dt
	
	love.graphics.setBackgroundColor(player.r/255 * back,player.g/255 * back,player.b/255 * back)
	
	swayTimer = swayTimer + swayS * dt
	
	screen.a = math.cos(swayTimer)/16
end

function game_draw()
	love.graphics.push()
	love.graphics.translate(cam.x,cam.y)
	
	level_draw()
	player_draw()
	particles_draw()
	
	love.graphics.pop()
	
	hud_draw()
end
sx = 1
sy = 1
isFullscreen = false
function love.keypressed(key)
	if(state == "menu") then
		if(key == "f") then
			love.graphics.toggleFullscreen()
		end
		if(key == "right") then
			sx = sx + 0.5
			sy = sy +0.5
			love.graphics.setMode(640 * sx, 480 * sy)
			screen.w = love.graphics.getWidth()
			screen.h = love.graphics.getHeight()
			tileSize = 20 * sx
		end
		if(key == "left") then
			sx = sx - 0.5
			sy = sy - 0.5
			love.graphics.setMode(640 * sx, 480 * sy)
			screen.w = love.graphics.getWidth()
			screen.h = love.graphics.getHeight()
			tileSize = 20 * sx
		end
	end
end